from __future__ import generators

print __name__

import os, sys, tennacles.core

class Author(object):

   def __init__(self, nombre, email, url):
      self.nombre = nombre
      self.email = email
      self.url = url

def walk(path, strip_length = 0):
   """
   path, ruta del directorio que se va a recorrer
   strip_length, si es 0, es el caso base, por lo que hay
   que calcular el valor. Es la longitud de las rutas compuestas
   que hay que quitar para obtener slo la ruta relativa.
   """
   if not strip_length:
      strip_length = len(os.path.join(path, ".")) - 1
         
   for item in os.listdir(path):
      full = os.path.join(path, item)
      if os.path.isdir(full):
         for val, partial in walk(full, strip_length):
            yield val, partial
      else:
         yield full, full[strip_length:]

class Project(object):

   def __init__(self, repository_path, author):
      self.repository_path = repository_path
      self.author = author
      self.resources = {}
      self.update_resources()

   def __clean_resource_update_flag(self):
      """Recorre los recursos limpiando la bandera de actualizacin"""
      for resource in self.resources.itervalues():
         resource.update_flat = 0

   def update_resources(self):
      self.__clean_resource_update_flag()
      
      base_path = os.path.split(self.repository_path)[0]
      if not base_path:
         base_path = "."
      for full_path, relative_path in walk(base_path):
         try:
            resource = self.resources[relative_path]
            resource.update()
         except KeyError:
            try:
               resource = tennacles.core.create_resource(relative_path, full_path)
               if resource:
                  self.resources[relative_path] = resource
            except tennacles.core.Resource_error, e:
               sys.stderr.write("No se pudo construir el recurso %s\n\t%s\n"
                  % (relative_path, e.message))

if __name__ == "__main__":
   p = Project("index.xml", None)

