"""
Resource manager

The resource manager is the central window the user will control.
From here, the user will be able to manage the repository
resources and launch the complementary editing windows.

TODO:
   Modify menus with the resource manager options
   Add graphical filter options
   Add paned areas
   Investigate window.show_all()
"""

print __name__
import gtk, gobject, tennacles.ui

def ifactory_cb():
   pass

g = 0

class Resources(gtk.Window):

   def clicked_button1(self, widget):
      print "Button pressed"

   def clicked_button2(self, widget, data1, data2):
      print "Button pressed with %s and %s" % (data1, data2)

   def delete_event(self, widget, event, data = None):
      return 0

   def destroy(self, *args):
      tennacles.ui.close("Resources")
      gtk.main_quit()

   def __init__(self, project):
      # create the new window
      super(Resources, self).__init__(gtk.WINDOW_TOPLEVEL)
      self.project = project
      global g
      g = project
      self.set_title("Gestor de recursos")

      # delete handler to exit GTK
      self.connect("delete_event", self.delete_event)
      self.connect("destroy", self.destroy)

      # create a box to package interface elements inside
      self.box1 = box1 = gtk.VBox(0, 0)
      self.add(self.box1)

      # create key binding handler
      accel_group = gtk.AccelGroup()
      self.add_accel_group(accel_group)

      # runtime construction of menu items
      self.menu_items = (
         ("/_Repositorio", None, None, 0, "<Branch>"),
         ("/Repositorio/tearoff1", None, None, 0, "<Tearoff>"),
         ("/Repositorio/_Actualizar recursos", None, None, 0),
         ("/Repositorio/sep1", None, None, 0, "<Separator>"),
         ("/Repositorio/_Seleccionar plugin", None, None, 0),
         ("/Repositorio/_Configurar plugin: xxx", None, None, 0),
         ("/Repositorio/_Exportar con: xxx", None, None, 0),
         ("/Repositorio/sep1", None, None, 0, "<Separator>"),
         ("/Repositorio/Cerrar _programa", None, self.destroy, 0),
      
         ("/_Nuevo recurso", None, None, 0, "<Branch>"),
         ("/Nuevo recurso/tearoff2", None, None, 0, "<Tearoff>"),
         ("/Nuevo recurso/Nueva _animacin".decode("latin1"), None, None, 0),
         ("/Nuevo recurso/Nueva accin _lgica".decode("latin1"), None, None, 0),
         ("/Nuevo recurso/Nueva a_ctor", None, None, 0),
         ("/Nuevo recurso/Nueva _escena", None, None, 0),
      
         ("/_Ayuda", None, None, 0, "<LastBranch>"),
         ("/Ayuda/tearoff3", None, None, 0, "<Tearoff>"),
         ("/Ayuda/_Manual", None, None, 0),
         ("/Ayuda/Acerca de _Tennacles", None, None, 0),
      )
      
      self.item_factory = item_factory = gtk.ItemFactory(gtk.MenuBar, '<main>', accel_group)
      item_factory.create_items(self.menu_items)
      self.menu_bar = menu_bar = item_factory.get_widget('<main>')
      box1.pack_start(menu_bar, 0, 0)
      menu_bar.show()

      # create paned areas
      self.h_paned = h_paned = gtk.HPaned()
      box1.pack_start(h_paned, 1, 1)
      h_paned.show()

      # create left treeview
      scrolled_window = gtk.ScrolledWindow()
      scrolled_window.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
      scrolled_window.set_size_request(200, 250)
      h_paned.add1(scrolled_window)

      model = ExplorerModel()
      model.mount(LocalNode('/'))

      tree_view = gtk.TreeView(model)

      def on_row_activated(tree_view, path, column):
         item = tree_view.get_model().on_get_iter(path)
#         if not item.is_directory():
         print 'Selected: ', item.path
            #print item.open().read()

      def on_row_change(tree_selection):
         print dir(tree_selection)
         print tree_selection.select_iter
         d = tree_selection.get_data("")
         print "Selected row's data", d

      tree_view.connect('row_activated', on_row_activated)
      tree_view.set_rules_hint(gtk.TRUE)
      tree_view.expand_row((0,), gtk.TRUE)
      selection = tree_view.get_selection()
      selection.connect('changed', on_row_change)
      
      cell = gtk.CellRendererText()
      column = gtk.TreeViewColumn("rbol de recursos".decode("latin1"), cell, text=0)
      tree_view.append_column(column)
      scrolled_window.add(tree_view)

      # create right list
      scrolled_window = gtk.ScrolledWindow()
      scrolled_window.set_shadow_type(gtk.SHADOW_ETCHED_IN)
      scrolled_window.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
      h_paned.add2(scrolled_window)
    
      model = create_model()
    
      treeview = gtk.TreeView(model)
      treeview.set_rules_hint(1)
      treeview.set_search_column(COLUMN_DESCRIPTION)
    
      scrolled_window.add(treeview)
      add_columns(treeview)
      scrolled_window.set_size_request(400, 250)
      
      # show elements
      box1.show()
      self.show_all()


# ExplorerModel - A GtkTreeModel to show directory trees in a GtkTreeView
# 
# Copyright (c) 2001  Michele Campeotto <micampe@micampe.it>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

import gtk
import gobject

import sys
import os.path

class LocalNode:
   def __init__(self, path, parent = None, _recursive = 1):
      """Create a new LocalNode."""
      self.path = path
      self.parent = parent
      self.list = None
      self.childrens = None
      if path[-1] == '/':
         if isinstance(self.parent, RootNode) or self.parent is None:
            self.name = self.path
         else:
            self.name = self.path.split('/')[-2] + '/'
         if _recursive:
            self.refresh()
      else:
         self.name = self.path.split('/')[-1]

   def get_childrens(self):
      """Return the childrens list of this LocalNode"""
      lista = map(lambda path, root=self.path, parent=self:
                      LocalNode("%s%s/" % (root, path),
                                parent, gtk.FALSE),
                  self.list)
      return lista

   def get_list(self):
      """Return the directory listing of this LocalNode"""
      # create temporary resources
      resources = []
      for resource in g.resources.keys():
         if resource[0] == "/":
            resources.append(resource)
         else:
            resources.append("/%s" % resource)

      # filter all which don't have same path
      resources = filter(lambda x: os.path.commonprefix([self.path, x]) == self.path, resources)
      # get only the interesting part of the path
      resources = map(lambda x: x[len(self.path):], resources)
      # get only items which have children elements
      resources = filter(lambda x: x.find("/") > 0, resources)
      temp = {}
      for resource in resources:
         temp [resource.split("/")[0]] = 1
      resources = temp.keys()
      print "%s listing: %s" % (self.path, resources)
      return resources

   def refresh(self):
      """Load the directory listing and childrens list"""
      self.list = self.get_list()
      self.childrens = self.get_childrens()

   def is_directory(self):
      return self.path[-1] == '/'

   def open(self):
      return open(self.path)


class RootNode:
   def __init__(self):
      self.path = 'root'
      self.parent = None
      self.list = None
      self.childrens = []
    
   def get_childrens(self):
      return childrens
    
   def get_list(self):
      return self.list
    
   def refresh(self):
      pass
    
   def is_directory(self):
      return 1

class ExplorerModel(gtk.GenericTreeModel):
    def __init__(self, root=None):
        gtk.GenericTreeModel.__init__(self)
        if root is None:
            self.root = RootNode()
        else:
            self.root = LocalNode(root)
    
    def on_get_flags(self):
        return 0
    
    def on_get_n_columns(self):
        return 1
    
    def on_get_column_type(self, column):
        assert column == 0
        return gobject.TYPE_STRING
    
    def on_get_path(self, node):
        return (0,)
    
    def on_get_value(self, node, column):
        assert column == 0
        return node.name
    
    def on_get_iter(self, path):
        if self.root.childrens is not None:
            cur_node = self.root
            for item in path:
                cur_node = cur_node.childrens[item]
                if cur_node.is_directory() and cur_node.childrens is None:
                    cur_node.refresh()
            return cur_node
    
    def on_iter_next(self, node):
        childs = node.parent.childrens
        try:
            return childs[childs.index(node) + 1]
        except IndexError:
            return None
    
    def on_iter_children(self, node):
        if node.childrens is not None:
            return node.childrens[0]
    
    def on_iter_has_child(self, node):
        if node.is_directory():
            if node.childrens is None:
                return gtk.TRUE
            else:
                return len(node.childrens) > 0
    
    def on_iter_n_children(self, node):
        if node is None:
            return len(self.root.list)
        else:
            return len(node.list)
    
    def on_iter_nth_child(self, node, n):
        if node is None:
            return self.root.childrens[n]
        else:
            return node.childrens[n]
    
    def on_iter_parent(self, node):
        return node.parent
    
    def mount(self, node):
        assert isinstance(self.root, RootNode)
        node.parent = self.root
        self.root.childrens.append(node)

COLUMN_ID          = 0
COLUMN_DESCRIPTION = 1
COLUMN_EDITABLE    = 2
COLUMN_ATTRIBUTES  = 3

data = [["pepe", "Vaya descripcin", "blah blah"],
 ["pepe2", "Joer que s", "otro blah blah"],
]

def create_model():
   store = gtk.ListStore(gobject.TYPE_STRING, gobject.TYPE_STRING,
      gobject.TYPE_BOOLEAN, gobject.TYPE_STRING)

   for item in data:
      iter = store.append()
      store.set(iter, COLUMN_ID, item[0].decode("latin1"),
         COLUMN_DESCRIPTION, item[1].decode("latin1"),
         COLUMN_EDITABLE, 1, COLUMN_ATTRIBUTES, item[2].decode("latin1"))
   return store

def add_columns(treeview):
   model = treeview.get_model()
    
   # column for ids
   column = gtk.TreeViewColumn('Id', gtk.CellRendererText(),
      text = COLUMN_ID)
    
    # set this column to a fixed sizing(of 50 pixels)
#    column.set_sizing(gtk.TREE_VIEW_COLUMN_FIXED)
#    column.set_fixed_width(50)
#    column.set_clickable(1)
    
   treeview.append_column(column)

   # column for description
   column = gtk.TreeViewColumn('Descripcin'.decode("latin1"),
      gtk.CellRendererText(), text = COLUMN_DESCRIPTION,
      editable = COLUMN_EDITABLE)
   treeview.append_column(column)
    
   # columns for attributes
   column = gtk.TreeViewColumn('Atributos',
      gtk.CellRendererText(), text = COLUMN_ATTRIBUTES)
   treeview.append_column(column)
    
