"""
Welcome window

This is the first window which will be presented to the user
whenever he starts Tennacles. It's a basic greeting window with
a few quick options to do.

TODO:
   make the listbox have a normal border
   make the listbox always have a selected item
   make the new game repository create the file selection window
   make the open game repository create the file selection window
   make open manual launch a browser
"""
print __name__

import gtk, gobject, tennacles.ui, tennacles.core
from tennacles.ui import File_selection

class Welcome(gtk.Window):

   def create_new_repository(self, widget):
      file_sel = File_selection("Crear repositorio")
      response = file_sel.run()
      filename = file_sel.get_filename()
      file_sel.destroy()
      if response == gtk.RESPONSE_OK:
         project = tennacles.core.Project(filename, author=None)
         self.hide()
         tennacles.ui.show("Resources", 1, project)
         self.destroy()
      else:
         print "File selection cancelled"

   def open_recent_repository(self, widget):
      tennacles.ui.show("Welcome")
      
   def clicked_button1(self, widget):
      print "Button pressed"

   def delete_event(self, widget, event, data = None):
      return 0

   def destroy(self, widget = None):
      self.hide()
      tennacles.ui.close("Welcome")
      gtk.main_quit()

   def __init__(self):
      # create the new window
      super(Welcome, self).__init__(gtk.WINDOW_TOPLEVEL)
      self.set_title("Lanzador Tennacles")
      self.set_border_width(10)

      # delete handler to exit GTK
      self.connect("delete_event", self.delete_event)
      self.connect("destroy", self.destroy)

      # create a box to package interface elements inside
      self.box1 = box1 = gtk.VBox(0, 0)
      self.add(box1)

      # create the different options
      self.button1 = button1 = gtk.Button("Crear un repositorio nuevo")
      box1.pack_start(button1, 1, 1, 0)
      button1.connect("clicked", self.create_new_repository)
      button1.set_border_width(5)
      button1.show()

      self.button2 = button2 = gtk.Button("Abrir un repositorio reciente")
      box1.pack_start(button2, 1, 1, 0)
      button2.connect("clicked", self.open_recent_repository)
      button2.set_border_width(5)
      button2.show()

      store = gtk.ListStore(gobject.TYPE_STRING)
      for entry in ["Last opened repository", "Anoter", "Oh, and this one",
         "First one, last to remember", "A repository not listed here"]:
         store.set(store.append(), 0, entry)

      self.list = list = gtk.TreeView(store)
      box1.pack_start(list)
      list.set_border_width(50)
      list.set_rules_hint(1)
      list.set_headers_visible(0)

      column = gtk.TreeViewColumn("Description", gtk.CellRendererText(), text=0)
      list.append_column(column)
      list.show()

      self.button3 = button3 = gtk.Button("Abrir manual")
      box1.pack_start(button3, 1, 1, 0)
      button3.connect("clicked", self.clicked_button1)
      button3.set_border_width(5)
      button3.show()
      
      self.button4 = button4 = gtk.Button("Cerrar esta ventana")
      box1.pack_start(button4, 1, 1, 0)
      button4.connect("clicked", self.destroy)
      button4.set_border_width(5)
      button4.show()
      
      # show elements
      box1.show()
      self.show()
